/*
Copyright 2022 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	context "context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	autoscalingv1alpha1 "knative.dev/serving/pkg/apis/autoscaling/v1alpha1"
	scheme "knative.dev/serving/pkg/client/clientset/versioned/scheme"
)

// PodAutoscalersGetter has a method to return a PodAutoscalerInterface.
// A group's client should implement this interface.
type PodAutoscalersGetter interface {
	PodAutoscalers(namespace string) PodAutoscalerInterface
}

// PodAutoscalerInterface has methods to work with PodAutoscaler resources.
type PodAutoscalerInterface interface {
	Create(ctx context.Context, podAutoscaler *autoscalingv1alpha1.PodAutoscaler, opts v1.CreateOptions) (*autoscalingv1alpha1.PodAutoscaler, error)
	Update(ctx context.Context, podAutoscaler *autoscalingv1alpha1.PodAutoscaler, opts v1.UpdateOptions) (*autoscalingv1alpha1.PodAutoscaler, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, podAutoscaler *autoscalingv1alpha1.PodAutoscaler, opts v1.UpdateOptions) (*autoscalingv1alpha1.PodAutoscaler, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*autoscalingv1alpha1.PodAutoscaler, error)
	List(ctx context.Context, opts v1.ListOptions) (*autoscalingv1alpha1.PodAutoscalerList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *autoscalingv1alpha1.PodAutoscaler, err error)
	PodAutoscalerExpansion
}

// podAutoscalers implements PodAutoscalerInterface
type podAutoscalers struct {
	*gentype.ClientWithList[*autoscalingv1alpha1.PodAutoscaler, *autoscalingv1alpha1.PodAutoscalerList]
}

// newPodAutoscalers returns a PodAutoscalers
func newPodAutoscalers(c *AutoscalingV1alpha1Client, namespace string) *podAutoscalers {
	return &podAutoscalers{
		gentype.NewClientWithList[*autoscalingv1alpha1.PodAutoscaler, *autoscalingv1alpha1.PodAutoscalerList](
			"podautoscalers",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *autoscalingv1alpha1.PodAutoscaler { return &autoscalingv1alpha1.PodAutoscaler{} },
			func() *autoscalingv1alpha1.PodAutoscalerList { return &autoscalingv1alpha1.PodAutoscalerList{} },
		),
	}
}
