/*
Copyright 2022 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	context "context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	servingv1beta1 "knative.dev/serving/pkg/apis/serving/v1beta1"
	scheme "knative.dev/serving/pkg/client/clientset/versioned/scheme"
)

// DomainMappingsGetter has a method to return a DomainMappingInterface.
// A group's client should implement this interface.
type DomainMappingsGetter interface {
	DomainMappings(namespace string) DomainMappingInterface
}

// DomainMappingInterface has methods to work with DomainMapping resources.
type DomainMappingInterface interface {
	Create(ctx context.Context, domainMapping *servingv1beta1.DomainMapping, opts v1.CreateOptions) (*servingv1beta1.DomainMapping, error)
	Update(ctx context.Context, domainMapping *servingv1beta1.DomainMapping, opts v1.UpdateOptions) (*servingv1beta1.DomainMapping, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, domainMapping *servingv1beta1.DomainMapping, opts v1.UpdateOptions) (*servingv1beta1.DomainMapping, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*servingv1beta1.DomainMapping, error)
	List(ctx context.Context, opts v1.ListOptions) (*servingv1beta1.DomainMappingList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *servingv1beta1.DomainMapping, err error)
	DomainMappingExpansion
}

// domainMappings implements DomainMappingInterface
type domainMappings struct {
	*gentype.ClientWithList[*servingv1beta1.DomainMapping, *servingv1beta1.DomainMappingList]
}

// newDomainMappings returns a DomainMappings
func newDomainMappings(c *ServingV1beta1Client, namespace string) *domainMappings {
	return &domainMappings{
		gentype.NewClientWithList[*servingv1beta1.DomainMapping, *servingv1beta1.DomainMappingList](
			"domainmappings",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *servingv1beta1.DomainMapping { return &servingv1beta1.DomainMapping{} },
			func() *servingv1beta1.DomainMappingList { return &servingv1beta1.DomainMappingList{} },
		),
	}
}
