/*
Copyright 2020 The Knative Authors

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	context "context"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
	networkingv1alpha1 "knative.dev/networking/pkg/apis/networking/v1alpha1"
	scheme "knative.dev/networking/pkg/client/clientset/versioned/scheme"
)

// ServerlessServicesGetter has a method to return a ServerlessServiceInterface.
// A group's client should implement this interface.
type ServerlessServicesGetter interface {
	ServerlessServices(namespace string) ServerlessServiceInterface
}

// ServerlessServiceInterface has methods to work with ServerlessService resources.
type ServerlessServiceInterface interface {
	Create(ctx context.Context, serverlessService *networkingv1alpha1.ServerlessService, opts v1.CreateOptions) (*networkingv1alpha1.ServerlessService, error)
	Update(ctx context.Context, serverlessService *networkingv1alpha1.ServerlessService, opts v1.UpdateOptions) (*networkingv1alpha1.ServerlessService, error)
	// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
	UpdateStatus(ctx context.Context, serverlessService *networkingv1alpha1.ServerlessService, opts v1.UpdateOptions) (*networkingv1alpha1.ServerlessService, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*networkingv1alpha1.ServerlessService, error)
	List(ctx context.Context, opts v1.ListOptions) (*networkingv1alpha1.ServerlessServiceList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *networkingv1alpha1.ServerlessService, err error)
	ServerlessServiceExpansion
}

// serverlessServices implements ServerlessServiceInterface
type serverlessServices struct {
	*gentype.ClientWithList[*networkingv1alpha1.ServerlessService, *networkingv1alpha1.ServerlessServiceList]
}

// newServerlessServices returns a ServerlessServices
func newServerlessServices(c *NetworkingV1alpha1Client, namespace string) *serverlessServices {
	return &serverlessServices{
		gentype.NewClientWithList[*networkingv1alpha1.ServerlessService, *networkingv1alpha1.ServerlessServiceList](
			"serverlessservices",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *networkingv1alpha1.ServerlessService { return &networkingv1alpha1.ServerlessService{} },
			func() *networkingv1alpha1.ServerlessServiceList { return &networkingv1alpha1.ServerlessServiceList{} },
		),
	}
}
